2005-06-15  Tor Lillqvist  <tml {at} novell.com>

	Make libegg build on Win32. Not really much tested or anything.

	* configure.in: Check for Win32. Check GTK+ target. Define
	autoconf substitution NO_UNDEFINED and automake conditional
	HAVE_GTK_TARGET_X11.

	* libegg/Makefile.am: Build background-monitor only for X11.

	* libegg/datetime/egg-datetime.c (gmtime_r, localtime_r)
	* libegg/thumbnailpreview/eggthumbnailpreview.c (gmtime_r)
	Implement for Win32, where gmtime() and localtime() are
	thread-safe.

	* libegg/dock/Makefile.am: Use NO_UNDEFINED.

	* libegg/dock/egg-dock.c
	* libegg/treeviewutils/egg-cell-renderer-text.c
	* libegg/treeviewutils/eggcellrendererpopup.c: Remove unnecessary
	inclusion of gdkx.h.

	* libegg/dock/*
	* libegg/tray/*
	* libegg/treeviewutils/eggaccelerators.c: Bypass X11 code unless
	building for X11. No corresponding Win32 code yet, I'm, only
	making this compile for now. Win32 code needs to be added if and
	when needed by some application.

	* libegg/pixbufthumbnail/egg-pixbuf-thumbnail.c: Use g_mkdir() and
	g_stat(), too.

	* libegg/recent-files/egg-recent-model.c (egg_recent_model_write_raw):
	Bypass fsync() on Win32.
	(egg_recent_model_lock_file, egg_recent_model_unlock_file): Bypass
	for now if we don't have lockf().

	* libegg/recent-files/egg-recent-util.c
	(egg_recent_util_get_unique_id): Use GetComputerName() on
	Win32. (Yes, there is a gethostname() on Windows, but it's in the
	WinSock API, and it seems silly to drag in WinSock just to get the
	machine's name.)

	* libegg/treeviewutils/eggcellrendererkeys.c (is_modifier):
	Implement for Win32.
1 /* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
 
2 /* eggtrayicon.h
 
3  * Copyright (C) 2002 Anders Carlsson <andersca@gnu.org>
 
4  *
 
5  * This library is free software; you can redistribute it and/or
 
6  * modify it under the terms of the GNU Lesser General Public
 
7  * License as published by the Free Software Foundation; either
 
8  * version 2 of the License, or (at your option) any later version.
 
9  *
 
10  * This library is distributed in the hope that it will be useful,
 
11  * but WITHOUT ANY WARRANTY; without even the implied warranty of
 
12  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 
13  * Lesser General Public License for more details.
 
14  *
 
15  * You should have received a copy of the GNU Lesser General Public
 
16  * License along with this library; if not, write to the
 
17  * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 
18  * Boston, MA 02111-1307, USA.
 
19  */
 
20  
21 #ifndef __EGG_TRAY_ICON_H__
 
22 #define __EGG_TRAY_ICON_H__
 
23  
24 #include <gtk/gtkplug.h>
 
25 #ifdef GDK_WINDOWING_X11
 
26 #include <gdk/gdkx.h>
 
27 #endif
 
28  
29 G_BEGIN_DECLS
 
30  
31 #define EGG_TYPE_TRAY_ICON		(egg_tray_icon_get_type ())
 
32 #define EGG_TRAY_ICON(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), EGG_TYPE_TRAY_ICON, EggTrayIcon))
 
33 #define EGG_TRAY_ICON_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), EGG_TYPE_TRAY_ICON, EggTrayIconClass))
 
34 #define EGG_IS_TRAY_ICON(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), EGG_TYPE_TRAY_ICON))
 
35 #define EGG_IS_TRAY_ICON_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), EGG_TYPE_TRAY_ICON))
 
36 #define EGG_TRAY_ICON_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), EGG_TYPE_TRAY_ICON, EggTrayIconClass))
 
37 	
 
38 typedef struct _EggTrayIcon	  EggTrayIcon;
 
39 typedef struct _EggTrayIconClass  EggTrayIconClass;
 
40  
41 struct _EggTrayIcon
 
42 {
 
43   GtkPlug parent_instance;
 
44  
45   guint stamp;
 
46   
 
47 #ifdef GDK_WINDOWING_X11
 
48   Atom selection_atom;
 
49   Atom manager_atom;
 
50   Atom system_tray_opcode_atom;
 
51   Atom orientation_atom;
 
52   Window manager_window;
 
53 #endif
 
54   GtkOrientation orientation;
 
55 };
 
56  
57 struct _EggTrayIconClass
 
58 {
  
59   GtkPlugClass parent_class;
 
60 };
 
61  
62 GType        egg_tray_icon_get_type       (void);
 
63  
64 EggTrayIcon *egg_tray_icon_new_for_screen (GdkScreen   *screen,
 
65 					   const gchar *name);
 
66  
67 EggTrayIcon *egg_tray_icon_new            (const gchar *name);
 
68  
69 guint        egg_tray_icon_send_message   (EggTrayIcon *icon,
 
70 					   gint         timeout,
 
71 					   const char  *message,
 
72 					   gint         len);
 
73 void         egg_tray_icon_cancel_message (EggTrayIcon *icon,
 
74 					   guint        id);
 
75  
76 GtkOrientation egg_tray_icon_get_orientation (EggTrayIcon *icon);
 
77 					    
 
78 G_END_DECLS
 
79  
80 #endif /* __EGG_TRAY_ICON_H__ */