2005-06-15  Tor Lillqvist  <tml {at} novell.com>

	Make libegg build on Win32. Not really much tested or anything.

	* configure.in: Check for Win32. Check GTK+ target. Define
	autoconf substitution NO_UNDEFINED and automake conditional
	HAVE_GTK_TARGET_X11.

	* libegg/Makefile.am: Build background-monitor only for X11.

	* libegg/datetime/egg-datetime.c (gmtime_r, localtime_r)
	* libegg/thumbnailpreview/eggthumbnailpreview.c (gmtime_r)
	Implement for Win32, where gmtime() and localtime() are
	thread-safe.

	* libegg/dock/Makefile.am: Use NO_UNDEFINED.

	* libegg/dock/egg-dock.c
	* libegg/treeviewutils/egg-cell-renderer-text.c
	* libegg/treeviewutils/eggcellrendererpopup.c: Remove unnecessary
	inclusion of gdkx.h.

	* libegg/dock/*
	* libegg/tray/*
	* libegg/treeviewutils/eggaccelerators.c: Bypass X11 code unless
	building for X11. No corresponding Win32 code yet, I'm, only
	making this compile for now. Win32 code needs to be added if and
	when needed by some application.

	* libegg/pixbufthumbnail/egg-pixbuf-thumbnail.c: Use g_mkdir() and
	g_stat(), too.

	* libegg/recent-files/egg-recent-model.c (egg_recent_model_write_raw):
	Bypass fsync() on Win32.
	(egg_recent_model_lock_file, egg_recent_model_unlock_file): Bypass
	for now if we don't have lockf().

	* libegg/recent-files/egg-recent-util.c
	(egg_recent_util_get_unique_id): Use GetComputerName() on
	Win32. (Yes, there is a gethostname() on Windows, but it's in the
	WinSock API, and it seems silly to drag in WinSock just to get the
	machine's name.)

	* libegg/treeviewutils/eggcellrendererkeys.c (is_modifier):
	Implement for Win32.
1 /* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */  
2 /* eggtraymanager.h
 
3  * Copyright (C) 2002 Anders Carlsson <andersca@gnu.org>
 
4  *
 
5  * This library is free software; you can redistribute it and/or
 
6  * modify it under the terms of the GNU Lesser General Public  
7  * License as published by the Free Software Foundation; either
 
8  * version 2 of the License, or (at your option) any later version.
 
9  *
 
10  * This library is distributed in the hope that it will be useful,
 
11  * but WITHOUT ANY WARRANTY; without even the implied warranty of
 
12  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 
13  * Lesser General Public License for more details.
 
14  *
 
15  * You should have received a copy of the GNU Lesser General Public  
16  * License along with this library; if not, write to the
 
17  * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 
18  * Boston, MA 02111-1307, USA.
 
19  */
 
20  
21 #ifndef __EGG_TRAY_MANAGER_H__
 
22 #define __EGG_TRAY_MANAGER_H__
 
23  
24 #include <gtk/gtkwidget.h>
 
25 #ifdef GDK_WINDOWING_X11
 
26 #include <gdk/gdkx.h>
 
27 #endif
 
28  
29 G_BEGIN_DECLS
 
30  
31 #define EGG_TYPE_TRAY_MANAGER			(egg_tray_manager_get_type ())  
32 #define EGG_TRAY_MANAGER(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), EGG_TYPE_TRAY_MANAGER, EggTrayManager))
 
33 #define EGG_TRAY_MANAGER_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), EGG_TYPE_TRAY_MANAGER, EggTrayManagerClass))
 
34 #define EGG_IS_TRAY_MANAGER(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), EGG_TYPE_TRAY_MANAGER))
 
35 #define EGG_IS_TRAY_MANAGER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), EGG_TYPE_TRAY_MANAGER))  
36 #define EGG_TRAY_MANAGER_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), EGG_TYPE_TRAY_MANAGER, EggTrayManagerClass))
 
37 	
 
38 typedef struct _EggTrayManager	     EggTrayManager;
 
39 typedef struct _EggTrayManagerClass  EggTrayManagerClass;
 
40 typedef struct _EggTrayManagerChild  EggTrayManagerChild;
 
41  
42 struct _EggTrayManager
 
43 {
 
44   GObject parent_instance;
 
45  
46 #ifdef GDK_WINDOWING_X11
 
47   Atom opcode_atom;
 
48   Atom selection_atom;
 
49   Atom message_data_atom;
 
50   Atom orientation_atom;
 
51 #endif
 
52   
 
53   GtkWidget *invisible;  
54   GdkScreen *screen;
 
55   GtkOrientation orientation;
 
56  
57   GList *messages;
 
58   GHashTable *socket_table;
 
59 };
 
60  
61 struct _EggTrayManagerClass
 
62 {
 
63   GObjectClass parent_class;
 
64  
65   void (* tray_icon_added)   (EggTrayManager      *manager,  
66 			      EggTrayManagerChild *child);
 
67   void (* tray_icon_removed) (EggTrayManager      *manager,  
68 			      EggTrayManagerChild *child);
 
69  
70   void (* message_sent)      (EggTrayManager      *manager,
 
71 			      EggTrayManagerChild *child,
 
72 			      const gchar         *message,
 
73 			      glong                id,
 
74 			      glong                timeout);
 
75   
 
76   void (* message_cancelled) (EggTrayManager      *manager,
 
77 			      EggTrayManagerChild *child,
 
78 			      glong                id);
 
79  
80   void (* lost_selection)    (EggTrayManager      *manager);
 
81 };
 
82  
83 GType           egg_tray_manager_get_type        (void);
 
84  
85 gboolean        egg_tray_manager_check_running   (GdkScreen           *screen);
 
86 EggTrayManager *egg_tray_manager_new             (void);
 
87 gboolean        egg_tray_manager_manage_screen   (EggTrayManager      *manager,
 
88 						  GdkScreen           *screen);
 
89 char         *egg_tray_manager_get_child_title (EggTrayManager      *manager,  
90 						  EggTrayManagerChild *child);
 
91 void            egg_tray_manager_set_orientation (EggTrayManager      *manager,  
92 						  GtkOrientation       orientation);
 
93 GtkOrientation  egg_tray_manager_get_orientation (EggTrayManager      *manager);
 
94  
95 G_END_DECLS
 
96  
97 #endif /* __EGG_TRAY_MANAGER_H__ */
 
