2003-02-11  Havoc Pennington  <hp {at} redhat.com>

	* libegg/tray/eggtraymanager.c (egg_tray_manager_check_running):
	kill HAVE_GTK_MULTIHEAD here.
	(egg_tray_manager_unmanage): fix calling GDK_WINDOW_XDISPLAY()
	on a GtkInvisible. Caused notification area to crash on
	shutdown.
1 #include <stdio.h>
 
2 #include <gtk/gtk.h>
 
3 #include "eggtraymanager.h"
 
4  
5 static void
 
6 lost_selection (EggTrayManager *manager)  
7 {
 
8   g_print ("We lost our selection");
 
9 }
 
10  
11 static void
 
12 tray_added (EggTrayManager *manager, GtkWidget *icon, GtkWidget *box)
 
13 {
 
14   gtk_widget_show (icon);
 
15   gtk_box_pack_start (GTK_BOX (box), icon, FALSE, FALSE, 0);  
16  
17   g_print ("tray added: \"%s\"\n", egg_tray_manager_get_child_title (manager, icon));  
18 }
 
19  
20 static void
 
21 tray_removed (EggTrayManager *manager, GtkWidget *icon, GtkWidget *box)
 
22 {
 
23   g_print ("tray removed: %p\n", icon);  
24 }
 
25  
26 static void
 
27 message_sent (EggTrayManager *manager, GtkWidget *icon, const char *text, glong id, glong timeout)  
28 {
 
29   g_print ("got message: \"%s\" (%ld)\n", text, id);
 
30 }
 
31  
32 static void
 
33 message_cancelled (EggTrayManager *manager, GtkWidget *icon, glong id)
 
34 {
 
35   g_print ("message cancelled (%ld)\n", id);
 
36     
 
37 }
 
38  
39 gint
 
40 main (gint argc, gchar **argv)
 
41 {
 
42   EggTrayManager *manager;
 
43   GtkWidget *window, *hbox;
 
44   
 
45   gtk_init (&argc, &argv);
 
46 #if 0
 
47   /* FIXME multihead */
 
48   if (egg_tray_manager_check_running_default_screen ())
 
49     {
 
50       g_warning ("a tray manager is already running.");
 
51       return 0;
 
52     }
 
53 #endif
 
54   
 
55   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 
56   g_signal_connect (window, "destroy",
 
57 		    G_CALLBACK (gtk_main_quit), NULL);
 
58   hbox = gtk_hbox_new (FALSE, 0);
 
59   gtk_container_add (GTK_CONTAINER (window), hbox);
 
60  
61   manager = egg_tray_manager_new ();
 
62   g_signal_connect (manager, "lost_selection",
 
63 		    G_CALLBACK (lost_selection), NULL);
 
64   g_signal_connect (manager, "tray_icon_added",
 
65 		    G_CALLBACK (tray_added), hbox);  
66   g_signal_connect (manager, "tray_icon_removed",
 
67 		    G_CALLBACK (tray_removed), hbox);
 
68   g_signal_connect (manager, "message_sent",
 
69 		    G_CALLBACK (message_sent), NULL);
 
70   g_signal_connect (manager, "message_cancelled",
 
71 		    G_CALLBACK (message_cancelled), NULL);
 
72  
73   if (!egg_tray_manager_manage_screen (manager,
 
74                                        gdk_screen_get_default ()))
 
75     {
 
76       g_warning ("could not set default screen.");
 
77     }
 
78  
79   gtk_widget_show_all (window);
 
80   
 
81   gtk_main ();
 
82   return 0;
 
83 }